function tFrames = forceD(adjMat,mulOps,opNames)
%FORCED		Find the SSG using the Force Directed Scheduling method.
%	tFrames = FORCED(adjMat,mulOps) returns a two-column vector 'tFrames'
%	describing the SSG (Scheduled Sequencing Graph) of the operations 
%	when scheduled according to the Force Directed Scheduling method with
%	optimal resource distribution.
%	At the moment, the latency of the resources (MUL, ALU) is expected to 
%	be one clock cycle.
%	The unscheduled flow has to be given in	'adjMat', while in 'mulOps' 
%	the resource type of the operations should be specified.
%
%	See also ASAP, ALAP, LISTSCHED, TOADJMAT, PARSE. 
%
%	Reference:	Force-Directed Scheduling for the Behavioral Synthesis of ASIC's
%				Pierre G. Paulin and John P. Knight
%				IEEE Trans on Computer-Aided Design, Vol. 8, No. 6, JUNE 1989
%				pages 661-679

% (c) H.J. Lincklaen Arriens, 
%     Delft University of Technology, November 2004
