function gen_INP(inpFilename,fxd,coeffs,inpSig)
% coeffs as output by  wdf2cir.m  or  LWDF2cir.m  
% e.g. cell array: {coeff_name}  {coeff_value}
% expected to be in correct sequence (in fact given by groupIOs.m }


if ~strcmp(inpFilename(end-3:end),'.INP')
	inpFilename = [ inpFilename '.INP' ];
end
fid = fopen( inpFilename, 'w' );

nCoeffs   = size(coeffs,1);
inpSig    = inpSig(:);
nInpVals  = length(inpSig);	
hexCoeffs = char( ones(nCoeffs,1) * (' '*ones(1,ceil(fxd(1)/4))) );
coeffsStr = [];
quantCoeffs = toSFixp(cell2mat(coeffs(:,2)),fxd,'round');
for i = 1:nCoeffs
	hexCoeffs(i,:) = fixp2hex(quantCoeffs(i),fxd);
	coeffsStr = [ coeffsStr cell2mat(coeffs(i,1)) ];
	if ( i ~= nCoeffs )
		coeffsStr = [ coeffsStr ',' ];
	end
end				

fprintf( fid, '-- [%d %d] fixed-point format\n', fxd(1), fxd(2) );
fprintf( fid, '-- coefficients: %s\n', coeffsStr );
for i = 1:nCoeffs
	fprintf( fid, 'x"%s"\n', hexCoeffs(i,:) );
end		

%hexInVals   = char( ones(nInpVals,1) * (' '*ones(1,ceil(fxd(1)/4))) );
quantInVals = toSFixp(inpSig,fxd,'round');
hexInVals   = fixp2hex(quantInVals,fxd);
fprintf( fid, '-- input function\n' );
for i = 1:nInpVals
	fprintf( fid, 'x"%s"\n', hexInVals(i,:) );
end		

if ( fid ~= -1 )
	fclose(fid);
end