function InOuts = groupIOs(CIRC_Data)
%GROUPIOS	For internal use only
%	InOuts = GROUPIOS(CIRC_Data)
%
%	See also  PARSE, SCHEDULE.
 
% (c) H.J. Lincklaen Arriens, 
%     Delft University of Technology, November 2004
%									  May 2005 (iocDef added)


iocDef   = CIRC_Data.iocDef;
inpNames = CIRC_Data.inpNames;
outNames = CIRC_Data.outNames;
dlydInps = CIRC_Data.dlydInps;

iChar     = iocDef(1);
oChar     = iocDef(2);
cChars    = iocDef(3:end');
nDlydInps = size(dlydInps,1);

constCoeffs = [];
dlydInpsTbl = [];
extInps     = [];
for i = 1:length(inpNames)
	firstChar = inpNames{i}(1); 
	if ( firstChar == iChar )
		if ( i <= nDlydInps )
			dlydInpsTbl = [ dlydInpsTbl; {inpNames{i}  dlydInps{i}} ];
		else
			extInps = [ extInps; {inpNames{i}} ];
		end
	else
		if ~isempty( strfind(cChars,firstChar) )
			constCoeffs = [ constCoeffs; {inpNames{i}} ];
		else
			error( 'GROUPIOS:  ''%s'': unrecognized input', inpNames{i} );
		end
	end		
end	

extOutps = [];
for i = 1:length(outNames)
	if ~any( strcmp(dlydInps,outNames{i}) )
		extOutps = [ extOutps; {outNames{i}} ];
	end
end

InOuts.constCoeffs = sort(constCoeffs);
InOuts.extInps     = sort(extInps);
InOuts.ssgInps     = sort( inpNames( char(inpNames(:,1)) == iChar )  );
InOuts.ssgOutps    = sort(outNames);
InOuts.extOutps    = sort(extOutps);
if ~isempty(dlydInpsTbl)
	% Sort the table with delayed in-outputs and use third column as a 
	% reference to the numbered outputs as used in the interconnection table
	[dlydInpsTbl(:,1),ix] = sort( dlydInpsTbl(:,1) );
	dlydInpsTbl(:,2)      = dlydInpsTbl(ix,2);
	for i = 1:length(ix)
		dlydInpsTbl(i,3) = {ix(i)};
	end
end
InOuts.dlydInpsTbl = dlydInpsTbl;
