function CIRC_Data = parse(inFilename)
%PARSE	For internal use only
%	CIRC_Data = PARSE(inFilename)
%	extracts data from textual circuit description.
%	The data returned in the structur CIRC_Data is made up as follows.
%		CIRC_Data.iocDef   : string defining the characters used for
%							 inputs, outputs and constant coefficients
%		CIRC_Data.iconnTbl
%	Input ports are negative values in iconnTbl (clmns 2 and 3)
% 	Output ports are in column 4
%	If no shift operations (<< or >>) are present, iconnTbl is a 
%	(number_of_operations,4) array, else a (number_of_operations,4,2) array.
%		CIRC_Data.xconnTbl
%		CIRC_Data.opTypes
%		CIRC_Data.opNames
%		CIRC_Data.inpNames
%		CIRC_Data.outNames
%		CIRC_Data.dlydInps
%
%	See also  GROUPIOS, SCHEDULE.

% (c) H.J. Lincklaen Arriens, 
%     Delft University of Technology, November 2004
%									  May 2005 ( iocDef added,
%									             enable a*b (no spaces) )
%									  June 2005, (.. << k) and (.. >> k) added
