%STARTUP	Setup paths for msclab_et4054
%	Will be run automatically when MATLAB is started from this directory

fid = fopen( 'fConfig.m', 'w' );
% edit the following path and strings to point to the 
% directories where the actual files are located
if ispc
	addpath( '<$YOUR_CIR_DIR>\win_matlab_R14\' ); 
	dotDirStr = '<$YOUR_CIR_DIR>\win_bin\';
	vhdDirStr = '<$YOUR_CIR_DIR>\vhdl\';
	fprintf( fid, 'dotDir = ''%s'';\n', dotDirStr ); 
	fprintf( fid, 'vhdDir = ''%s'';\n', vhdDirStr );
else
	addpath( '<$YOUR_CIR_DIR>/lnx_matlab_R14/' );
	vhdDirStr = '<$YOUR_CIR_DIR>/vhdl/';
	dotDirStr = '<$YOUR_GRAPHVIZ_BIN_DIR>';
	fprintf( fid, 'dotDir = ''%s'';\n', dotDirStr ); 
	fprintf( fid, 'vhdDir = ''%s'';\n', vhdDirStr );
end
fclose( fid );

verNum = str2double( version('-release') );
if ( verNum ~= 14 )
	beep;
	fprintf( '\nYou have a MATLAB version older than Release 14 ...\n' );
	fprintf( 'Use the xxx_matlab_R13.zip package ...\n' );
	if ( verNum < 13 )
		fprintf( 'but it has NOT been tested on Release %d !\n', verNum ); 
	end
end
fprintf( '\n' );

% specify your favorite .cir dir here
if ispc
	cd( '<$YOUR_CIR_DIR>' ); 
end

clear all
