function adjMat = toAdjMat(iconnTbl)
%TOADJMAT	Converts an interconnection table into an adjacency matrix
%	adjMat = TOADJMAT(iconnTbl), where 'iconnTbl' can be one of the 
%	outputs from 'parse.m'.
%
%	See also PARSE. 

% (c) H.J. Lincklaen Arriens, 
%     Delft University of Technology, November 2004
%									  June 2005, adapted to shift possibility


% disregard multidimensional part which is present
% in case left or right shift operators have been used
iconnTbl = iconnTbl(:,:,1);

nodes = sort(iconnTbl(:,1));
nNodes = length(nodes);
%if ( nodes' ~= [1:nNodes] )
%	error( 'Input format not correct ...' );
%end
adjMat = zeros(nNodes);
for inNo = 2:3
	ix_to   = find( iconnTbl(:,inNo) > 0 );
	ix_from = iconnTbl(ix_to,inNo);
	for i = 1:length(ix_to)
		adjMat(ix_from(i),ix_to(i)) = 1;
	end
end

%{
% first version
for i = 1:nNodes
	if ( iconnTbl(i,2) > 0 )
		adjMat( iconnTbl(i,2), i ) = 1;
	end
	if ( iconnTbl(i,3) > 0 )
		adjMat( iconnTbl(i,3), i ) = 1;
	end
end
%}
		
